define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'school/classes/activity/activity_auth/index' + location.search,
                    add_url: 'school/classes/activity/activity_auth/add'+ location.search,
                    edit_url: 'school/classes/activity/activity_auth/edit'+ location.search,
                    del_url: 'school/classes/activity/activity_auth/del',
                    multi_url: 'school/classes/activity/activity_auth/multi',
                    import_url: 'school/classes/activity/activity_auth/import',
                    table: 'school_classes_activity_auth',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'weigh',
                fixedColumns: true,
                fixedRightNumber: 1,
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'classes_activity_id',visible:false, title: __('Classes_activity_id')},
                        {field: 'manystore_id',visible:false, title: __('Manystore_id')},
                        {field: 'shop_id',visible:false, title: __('Shop_id')},
                        {field: 'title', title: __('Title'), operate: 'LIKE'},
                        {field: 'headimage', title: __('Headimage'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'images', title: __('Images'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.images},
                        {field: 'auth_status', title: __('Auth_status'), searchList: {"0":__('Auth_status 0'),"1":__('Auth_status 1'),"2":__('Auth_status 2')}, formatter: Table.api.formatter.status},
                        {field: 'status', title: __('Status'), searchList: {"1":__('Status 1'),"2":__('Status 2'),"3":__('Status 3')}, formatter: Table.api.formatter.status},


                        {field: 'has_expire', title: __('Has_expire'), searchList: {"1":__('Has_expire 1'),"2":__('Has_expire 2')}, formatter: Table.api.formatter.normal},
                        {field: 'feel', title: __('是否免费'), searchList: {"0":__('付费活动'),"1":__('免费活动')}, formatter: Table.api.formatter.normal},



                        {field: 'address_type', title: __('Address_type'), searchList: {"1":__('Address_type 1'),"2":__('Address_type 2')}, formatter: Table.api.formatter.normal},
                        {field: 'address_city', title: __('Address_city'), operate: 'LIKE'},
                        {field: 'province', title: __('Province')},
                        {field: 'city', title: __('City')},
                        {field: 'district', title: __('District')},
                        {field: 'address', title: __('Address'), operate: 'LIKE'},
                        {field: 'address_detail', title: __('Address_detail'), operate: 'LIKE'},
                        {field: 'longitude', title: __('Longitude'), operate: 'LIKE'},
                        {field: 'latitude', title: __('Latitude'), operate: 'LIKE'},
                        {field: 'start_time', title: __('Start_time')},
                        {field: 'end_time', title: __('End_time')},
                        {field: 'sign_start_time', title: __('Sign_start_time')},
                        {field: 'sign_end_time', title: __('Sign_end_time')},
                        {field: 'price', title: __('Price'), operate:'BETWEEN'},
                        {field: 'people_num', title: __('People_num')},
                        {field: 'item', title: __('Item'), operate: 'LIKE'},
                                               {field: 'weigh', title: __('Weigh'), operate: false},
                        {field: 'recommend', title: __('Recommend'), searchList: {"0":__('Recommend 0'),"1":__('Recommend 1')}, formatter: Table.api.formatter.normal},
                        {field: 'hot', title: __('Hot'), searchList: {"0":__('Hot 0'),"1":__('Hot 1')}, formatter: Table.api.formatter.normal},
                        {field: 'new', title: __('New'), searchList: {"0":__('New 0'),"1":__('New 1')}, formatter: Table.api.formatter.normal},
                        {field: 'selfhot', title: __('Selfhot'), searchList: {"0":__('Selfhot 0'),"1":__('Selfhot 1')}, formatter: Table.api.formatter.normal},
                                                {field: 'reason', title: __('Reason'), operate: 'LIKE'},
                        {field: 'sale', title: __('Sale')},
                        {field: 'stock', title: __('Stock')},
                        {field: 'views', title: __('Views')},
                        // {field: 'expirestatus', title: __('Expirestatus'), searchList: {"1":__('Expirestatus 1'),"2":__('Expirestatus 2')}, formatter: Table.api.formatter.status},
                        {field: 'add_type', title: __('Add_type'), searchList: {"1":__('Add_type 1'),"2":__('Add_type 2')}, formatter: Table.api.formatter.normal},
                        {field: 'add_id', title: __('Add_id')},
                        {field: 'admin_id', title: __('Admin_id')},
                        {field: 'auth_time', title: __('Auth_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'createtime', title: __('Createtime')},
                        {field: 'updatetime', title: __('Updatetime')},
                        {field: 'schoolclassesactivity.id', title: __('Schoolclassesactivity.id')},
                        {field: 'manystore.nickname', title: __('Manystore.nickname'), operate: 'LIKE'},
                        {field: 'manystoreshop.name', title: __('Manystoreshop.name'), operate: 'LIKE'},
                        {field: 'manystoreshop.logo', title: __('Manystoreshop.logo'), operate: 'LIKE'},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            $(document).on('click', '.btn-changeuser', function (event) {
                var url = $(this).attr('data-url');
                if(!url) return false;
                var title = $(this).attr('title');
                var width = $(this).attr('data-width');
                var height = $(this).attr('data-height');
                // var ids = $(this).attr('data-id');
                var area = ['98%','98%'];
                var options = {
                    shadeClose: false,
                    shade: [0.3, '#393D49'],
                    area: area,
                    callback:function(ret){//回调方法，需要在本页面Controller中增加方法监听且调用Fast.api.close(ret)传递结果;
                        Fast.api.close(ret);
                    }
                };
                Fast.api.open(url,title,options);
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        recyclebin: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    'dragsort_url': ''
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: 'school/classes/activity/activity_auth/recyclebin' + location.search,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'title', title: __('Title'), align: 'left'},
                        {
                            field: 'deletetime',
                            title: __('Deletetime'),
                            operate: 'RANGE',
                            addclass: 'datetimerange',
                            formatter: Table.api.formatter.datetime
                        },
                        {
                            field: 'operate',
                            width: '130px',
                            title: __('Operate'),
                            table: table,
                            events: Table.api.events.operate,
                            buttons: [
                                {
                                    name: 'Restore',
                                    text: __('Restore'),
                                    classname: 'btn btn-xs btn-info btn-ajax btn-restoreit',
                                    icon: 'fa fa-rotate-left',
                                    url: 'school/classes/activity/activity_auth/restore',
                                    refresh: true
                                },
                                {
                                    name: 'Destroy',
                                    text: __('Destroy'),
                                    classname: 'btn btn-xs btn-danger btn-ajax btn-destroyit',
                                    icon: 'fa fa-times',
                                    url: 'school/classes/activity/activity_auth/destroy',
                                    refresh: true
                                }
                            ],
                            formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
            generrate.setOfflineType($("input:radio[name='row[address_type]']").val());
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {

                $(document).on("dp.change", "#add-form .datetimerange", function () {
                    $(this).parent().prev().find("input").trigger("change");
                });

                $(document).on("dp.change", "#add-form .datetimepicker", function () {
                    $(this).parent().prev().find("input").trigger("change");
                });
                $(document).on("dp.change", "#edit-form .datetimerange", function () {
                    $(this).parent().prev().find("input").trigger("change");
                });

                $(document).on("dp.change", "#edit-form .datetimepicker", function () {
                    $(this).parent().prev().find("input").trigger("change");
                });

                $(document).on("fa.event.appendfieldlist", "#add-form .btn-append", function (e, obj) {
                    // Form.api.bindevent($("form[role=form]"));
                    // // //绑定动态下拉组件
                    Form.events.selectpage(obj);
                    // // //绑定日期组件
                    Form.events.daterangepicker(obj);
                    Form.events.datetimepicker(obj);
                    // // Form.events.datetimerange(obj);
                    // Form.api.bindevent(this);
                    // //绑定上传组件
                    // Form.events.faupload(obj);

                    // //上传成功回调事件，变更按钮的背景
                    // $(".upload-image", obj).data("upload-success", function (data) {
                    //     $(this).css("background-image", "url('" + Fast.api.cdnurl(data.url) + "')");
                    // })
                });
                $(document).on("fa.event.appendfieldlist", "#edit-form .btn-append", function (e, obj) {
                    // Form.api.bindevent($("form[role=form]"));
                    // // //绑定动态下拉组件
                    Form.events.selectpage(obj);
                    // // //绑定日期组件
                    Form.events.daterangepicker(obj);
                    Form.events.datetimepicker(obj);
                    // // Form.events.datetimerange(obj);
                    // Form.api.bindevent(this);
                    // //绑定上传组件
                    // Form.events.faupload(obj);

                    // //上传成功回调事件，变更按钮的背景
                    // $(".upload-image", obj).data("upload-success", function (data) {
                    //     $(this).css("background-image", "url('" + Fast.api.cdnurl(data.url) + "')");
                    // })
                });

                $("#c-address_city").on("cp:updated", function() {
                    var citypicker = $(this).data("citypicker");
                    var province = citypicker.getCode("province");
                    var city = citypicker.getCode("city");
                    var district = citypicker.getCode("district");
                    if(province){
                        $("#province").val(province);
                    }
                    if(city){
                        $("#city").val(city);
                    }
                    if(district){
                        $("#district").val(district);
                    }
                    $(this).blur();
                });
                generrate.listen();

                $(document).on('click', '.btn-changeuser', function (event) {
                    var url = $(this).attr('data-url');
                    if(!url) return false;
                    var title = $(this).attr('title');
                    var width = $(this).attr('data-width');
                    var height = $(this).attr('data-height');
                    // var ids = $(this).attr('data-id');
                    var area = ['98%','98%'];
                    var options = {
                        shadeClose: false,
                        shade: [0.3, '#393D49'],
                        area: area,
                        callback:function(ret){//回调方法，需要在本页面Controller中增加方法监听且调用Fast.api.close(ret)传递结果;
                            Fast.api.close(ret);
                        }
                    };
                    Fast.api.open(url,title,options);
                });


                Form.api.bindevent($("form[role=form]"));
            }
        }
    };

    var generrate = {
        listen:function () {
            this.offlineListen();
            this.priceListen();
        },
        offlineListen:function () {
            var that = this;
            // console.log($("input:radio[name='row[address_type]']").val())
            // this.setOfflineType($("input:radio[name='row[address_type]']").val());
            $("input:radio[name='row[address_type]']").change(function (){
                that.setOfflineType($(this).val());
            });
        },
        setOfflineType:function (val) {
            switch (val) {
                case '1':
                    $('#c_position').hide();
                    break;
                case '2':
                    $('#c_position').show();
                    break;
            }
        },
        priceListen:function () {
            $('#spec').bind('input propertychange', function(){
                var length = $("#spec").val().length;
                console.log(length);
            });
        }
    }


    return Controller;
});